local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local equipped = x.Equipped
local talent = x.Talent
local cooldown = x.Cooldown
local buff = x.Buff
local action = x.Action
local dot = x.Dot

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()

	s.UpdateTarget()

	x.InCombat = s.InCombat()
	x.Spec = s.TalentMastery()
	x.MaxHealth = s.MaxHealth("player")
	x.Health = s.Health("player")
	x.ActiveEnemies = s.SpellTargets()
	x.Haste = 1 + UnitSpellHaste("player") / 100
	x.MaxGCD = 1.5 / x.Haste
	if x.MaxGCD < 1 then
		x.MaxGCD = 1
	end

	if x.Spec == 1 then
		-- Balance

		s.UpdateBuff(194223, "Celestial Alignment")
		s.UpdateBuff(102560, "incarnation")
		s.UpdateBuff(202737, "Blessing of Elune")
		s.UpdateBuff(202739, "Blessing of An'she")
		s.UpdateBuff(164545, "Solar Empowerment")
		s.UpdateBuff(164547, "Lunar Empowerment")

		s.UpdateDoT(8921, "Moonfire")
		s.UpdateDoT(93402, "Sunfire")
		s.UpdateDoT(202347, "Stellar Flare")

		s.UpdateCooldown(202770, "Fury of Elune")

		x.MoonCharges = GetSpellCharges(202767--[[New Moon]])
		x.AstralPower = s.Power("player", SPELL_POWER_LUNAR_POWER )
		if s.Casting(190984--[[Solar Wrath]], "player") then
			x.AstralPower = x.AstralPower + 8 * (1 + s.If(buff.blessing_of_elune.up, 0.25, 0)) * (1 + s.If(buff.incarnation.up, 0.5, 0))
			buff.solar_empowerment.stack = buff.solar_empowerment.stack - 1
			if buff.solar_empowerment.stack == 0 then
				buff.solar_empowerment.up = false
				buff.solar_empowerment.down = true
			end
		end
		if s.Casting(194153--[[Lunar Strike]], "player") then
			x.AstralPower = x.AstralPower + 12 * (1 + s.If(buff.blessing_of_elune.up, 0.25, 0)) * (1 + s.If(buff.incarnation.up, 0.5, 0))
			buff.lunar_empowerment.stack = buff.lunar_empowerment.stack - 1
			if buff.lunar_empowerment.stack == 0 then
				buff.lunar_empowerment.up = false
				buff.lunar_empowerment.down = true
			end
		end
		if s.Casting(202767--[[New Moon]], "player") then
			x.MoonCharges = x.MoonCharges - 1
			x.AstralPower = x.AstralPower + 10
		end
		if s.Casting(202768--[[Half Moon]], "player") then
			x.MoonCharges = x.MoonCharges - 1
			x.AstralPower = x.AstralPower + 20
		end
		if s.Casting(202771--[[Full Moon]], "player") then
			x.MoonCharges = x.MoonCharges - 1
			x.AstralPower = x.AstralPower + 40
		end
		x.AstralPowerDeficit = s.MaxPower("player", SPELL_POWER_LUNAR_POWER) - x.AstralPower

		s.UpdateBuff(209406, "Oneth's Intuition")
		s.UpdateBuff(224706, "The Emerald Dreamcatcher")
		x.StarsurgeCost = 40
		if buff.oneths_intuition.up then
			x.StarsurgeCost = 0
		else
			x.StarsurgeCost = x.StarsurgeCost - buff.the_emerald_dreamcatcher.stack * 5
		end

		s.UpdateBuff(209407, "Oneth's Overconfidence")
		x.StarfallCost = 60
		if buff.oneths_overconfidence.up then
			x.StarfallCost = 0
		else
			x.StarfallCost = x.StarfallCost - buff.the_emerald_dreamcatcher.stack * 5
		end

		a.Flash("stance,choose=moonkin_form")
		a.Flash("solar_beam") -- interrupt spellcasting

		s.UpdateCooldown(202767, "New Moon")
		s.UpdateCooldown(202768, "Half Moon")
		s.UpdateCooldown(202771, "Full Moon")
		if talent.fury_of_elune.enabled and cooldown.fury_of_elune.remains < x.TimeToDie then
			s.UpdateBuff(202770, "Fury of Elune")
			s.UpdateBuff(202425, "Warrior of Elune")
			s.UpdateCooldown(202425, "Warrior of Elune")
			a.Flash("potion,name=potion_of_prolonged_power,if=buff.celestial_alignment.up|buff.incarnation.up"
					,"blessing_of_elune,if=active_enemies<=2&talent.blessing_of_the_ancients.enabled&buff.blessing_of_elune.down"
					,"blessing_of_elune,if=active_enemies>=3&talent.blessing_of_the_ancients.enabled&buff.blessing_of_anshe.down"
					,"berserking,if=buff.celestial_alignment.up|buff.incarnation.up"
					-- Fury of Elune
					,"incarnation,if=astral_power>=95&cooldown.fury_of_elune.remains<=gcd"
					,"force_of_nature,if=!buff.fury_of_elune.up"
					,"fury_of_elune,if=astral_power>=95"
					,"new_moon,if=((charges=2&recharge_time<5)|charges=3)&&(buff.fury_of_elune.up|(cooldown.fury_of_elune.remains>gcd*3&astral_power<=90))"
					,"half_moon,if=((charges=2&recharge_time<5)|charges=3)&&(buff.fury_of_elune.up|(cooldown.fury_of_elune.remains>gcd*3&astral_power<=80))"
					,"full_moon,if=((charges=2&recharge_time<5)|charges=3)&&(buff.fury_of_elune.up|(cooldown.fury_of_elune.remains>gcd*3&astral_power<=60))"
					,"astral_communion,if=buff.fury_of_elune.up&astral_power<=25"
					,"warrior_of_elune,if=buff.fury_of_elune.up|(cooldown.fury_of_elune.remains>=35&buff.lunar_empowerment.up)"
					,"lunar_strike,if=buff.warrior_of_elune.up&(astral_power<=90|(astral_power<=85&buff.incarnation.up))"
					,"new_moon,if=astral_power<=90&buff.fury_of_elune.up"
					,"half_moon,if=astral_power<=80&buff.fury_of_elune.up&astral_power>cast_time*12"
					,"full_moon,if=astral_power<=60&buff.fury_of_elune.up&astral_power>cast_time*12"
					,"moonfire,if=buff.fury_of_elune.down&remains<=6.6"
					,"sunfire,if=buff.fury_of_elune.down&remains<5.4"
					,"stellar_flare,if=remains<7.2&active_enemies=1"
					,"starfall,if=(active_enemies>=2&talent.stellar_flare.enabled|active_enemies>=3)&buff.fury_of_elune.down&cooldown.fury_of_elune.remains>10"
					,"starsurge,if=active_enemies<=2&buff.fury_of_elune.down&cooldown.fury_of_elune.remains>7"
					,"starsurge,if=buff.fury_of_elune.down&((astral_power>=92&cooldown.fury_of_elune.remains>gcd*3)|(cooldown.warrior_of_elune.remains<=5&cooldown.fury_of_elune.remains>=35&buff.lunar_empowerment.stack<2))"
					,"solar_wrath,if=buff.solar_empowerment.up"
					,"lunar_strike,if=buff.lunar_empowerment.stack=3|(buff.lunar_empowerment.remains<5&buff.lunar_empowerment.up)|active_enemies>=2"
					,"solar_wrath")
		elseif equipped.the_emerald_dreamcatcher and x.ActiveEnemies <= 1 then
			s.UpdateCastTime(205636, "Force of Nature")
			s.UpdateCastTime(191034, "Starfall")
			s.UpdateCastTime(194153, "Lunar Strike")
			s.UpdateCastTime(190984, "Solar Wrath")
			s.UpdateCastTime(202767, "New Moon")
			s.UpdateCastTime(202768, "Half Moon")
			s.UpdateCastTime(202771, "Full Moon")
			a.Flash("potion,name=potion_of_prolonged_power,if=buff.celestial_alignment.up|buff.incarnation.up"
					,"blessing_of_elune,if=active_enemies<=2&talent.blessing_of_the_ancients.enabled&buff.blessing_of_elune.down"
					,"blessing_of_elune,if=active_enemies>=3&talent.blessing_of_the_ancients.enabled&buff.blessing_of_anshe.down"
					,"berserking,if=buff.celestial_alignment.up|buff.incarnation.up"
					-- The Emerald Dreamcatcher
					,"astral_communion,if=astral_power.deficit>=75&buff.the_emerald_dreamcatcher.up"
					,"incarnation,if=astral_power>=60|buff.bloodlust.up"
					,"celestial_alignment,if=astral_power>=60&!buff.the_emerald_dreamcatcher.up"
					,"starsurge,if=(gcd.max*astral_power/26)>target.time_to_die"
					,"stellar_flare,cycle_targets=1,max_cycle_targets=4,if=active_enemies<4&remains<7.2"
					,"moonfire,if=((talent.natures_balance.enabled&remains<3)|(remains<6.6&!talent.natures_balance.enabled))&(buff.the_emerald_dreamcatcher.remains>gcd.max|!buff.the_emerald_dreamcatcher.up)"
					,"sunfire,if=((talent.natures_balance.enabled&remains<3)|(remains<5.4&!talent.natures_balance.enabled))&(buff.the_emerald_dreamcatcher.remains>gcd.max|!buff.the_emerald_dreamcatcher.up)"
					,"force_of_nature,if=buff.the_emerald_dreamcatcher.remains>execute_time"
					,"starfall,if=buff.oneths_overconfidence.react&buff.the_emerald_dreamcatcher.remains>execute_time"
					,"new_moon,if=astral_power.deficit>=10&buff.the_emerald_dreamcatcher.remains>execute_time&astral_power>=16"
					,"half_moon,if=astral_power.deficit>=20&buff.the_emerald_dreamcatcher.remains>execute_time&astral_power>=6"
					,"full_moon,if=astral_power.deficit>=40&buff.the_emerald_dreamcatcher.remains>execute_time"
					,"lunar_strike,if=(buff.lunar_empowerment.up&buff.the_emerald_dreamcatcher.remains>execute_time&(!(buff.celestial_alignment.up|buff.incarnation.up)&astral_power.deficit>=15|(buff.celestial_alignment.up|buff.incarnation.up)&astral_power.deficit>=22.5))&spell_haste<0.4"
					,"solar_wrath,if=buff.solar_empowerment.stack>1&buff.the_emerald_dreamcatcher.remains>2*execute_time&astral_power>=6&(dot.moonfire.remains>5|(dot.sunfire.remains<5.4&dot.moonfire.remains>6.6))&(!(buff.celestial_alignment.up|buff.incarnation.up)&astral_power.deficit>=10|(buff.celestial_alignment.up|buff.incarnation.up)&astral_power.deficit>=15)"
					,"lunar_strike,if=buff.lunar_empowerment.up&buff.the_emerald_dreamcatcher.remains>execute_time&astral_power>=11&(!(buff.celestial_alignment.up|buff.incarnation.up)&astral_power.deficit>=15|(buff.celestial_alignment.up|buff.incarnation.up)&astral_power.deficit>=22.5)"
					,"solar_wrath,if=buff.solar_empowerment.up&buff.the_emerald_dreamcatcher.remains>execute_time&astral_power>=16&(!(buff.celestial_alignment.up|buff.incarnation.up)&astral_power.deficit>=10|(buff.celestial_alignment.up|buff.incarnation.up)&astral_power.deficit>=15)"
					,"starsurge,if=(buff.the_emerald_dreamcatcher.up&buff.the_emerald_dreamcatcher.remains<gcd.max)|astral_power>85|((buff.celestial_alignment.up|buff.incarnation.up)&astral_power>30)"
					,"starfall,if=buff.oneths_overconfidence.up"
					,"new_moon,if=astral_power.deficit>=10"
					,"half_moon,if=astral_power.deficit>=20"
					,"full_moon,if=astral_power.deficit>=40"
					,"solar_wrath,if=buff.solar_empowerment.up"
					,"lunar_strike,if=buff.lunar_empowerment.up"
					,"solar_wrath")
		elseif (x.ActiveEnemies >= 2 and talent.stellar_drift.enabled) or x.ActiveEnemies >= 3 then
			s.UpdateBuff(242232, "Astral Acceleration")
			s.UpdateBuff(202425, "Warrior of Elune")
			s.UpdateDebuff(197637, "Stellar Empowerment")
			a.Flash("potion,name=potion_of_prolonged_power,if=buff.celestial_alignment.up|buff.incarnation.up"
					,"blessing_of_elune,if=active_enemies<=2&talent.blessing_of_the_ancients.enabled&buff.blessing_of_elune.down"
					,"blessing_of_elune,if=active_enemies>=3&talent.blessing_of_the_ancients.enabled&buff.blessing_of_anshe.down"
					,"berserking,if=buff.celestial_alignment.up|buff.incarnation.up"
					-- AoE
					,"astral_communion,if=astral_power.deficit>=79"
					,"warrior_of_elune"
					,"incarnation,if=astral_power>=40"
					,"celestial_alignment,if=astral_power>=40"
					,"starfall,if=debuff.stellar_empowerment.remains<gcd.max*2|astral_power.deficit<22.5|(buff.celestial_alignment.remains>8|buff.incarnation.remains>8)|target.time_to_die<8"
					,"stellar_flare,target_if=refreshable,if=target.time_to_die>10"
					,"sunfire,target_if=refreshable,if=astral_power.deficit>7&target.time_to_die>4"
					,"moonfire,target_if=refreshable,if=astral_power.deficit>7&target.time_to_die>4"
					,"force_of_nature"
					,"starsurge,if=buff.oneths_intuition.react&(!buff.astral_acceleration.up|buff.astral_acceleration.remains>5|astral_power.deficit<44)"
					,"new_moon,if=astral_power.deficit>14&(!(buff.celestial_alignment.up|buff.incarnation.up)|(charges=2&recharge_time<5)|charges=3)"
					,"half_moon,if=astral_power.deficit>24"
					,"full_moon,if=astral_power.deficit>44"
					,"lunar_strike,if=buff.warrior_of_elune.up"
					,"solar_wrath,if=buff.solar_empowerment.up"
					,"lunar_strike,if=buff.lunar_empowerment.up"
					,"lunar_strike,if=spell_targets.lunar_strike>=4|spell_haste<0.45"
					,"solar_wrath")
		else
			s.UpdateBuff(209406, "Oneth's Intuition")
			s.UpdateBuff(209407, "Oneth's Overconfidence")
			s.UpdateBuff(242232, "Astral Acceleration")
			s.UpdateBuff(252767, "Solar Solstice")
			s.UpdateDebuff(197637, "Stellar Empowerment")
			s.UpdateBuff(202425, "Warrior of Elune")
			a.Flash("potion,name=potion_of_prolonged_power,if=buff.celestial_alignment.up|buff.incarnation.up"
					,"blessing_of_elune,if=active_enemies<=2&talent.blessing_of_the_ancients.enabled&buff.blessing_of_elune.down"
					,"blessing_of_elune,if=active_enemies>=3&talent.blessing_of_the_ancients.enabled&buff.blessing_of_anshe.down"
					,"berserking,if=buff.celestial_alignment.up|buff.incarnation.up"
					-- Single Target
					,"astral_communion,if=astral_power.deficit>=79"
					,"warrior_of_elune"
					,"incarnation,if=astral_power>=40"
					,"celestial_alignment,if=astral_power>=40"
					,"force_of_nature"
					,"stellar_flare,target_if=refreshable,if=target.time_to_die>10"
					,"moonfire,target_if=refreshable,if=((talent.natures_balance.enabled&remains<3)|remains<6.6)&astral_power.deficit>7&target.time_to_die>8"
					,"sunfire,target_if=refreshable,if=((talent.natures_balance.enabled&remains<3)|remains<5.4)&astral_power.deficit>7&target.time_to_die>8"
					,"starsurge,if=buff.oneths_intuition.react"
					,"starfall,if=(buff.oneths_overconfidence.react&(!buff.astral_acceleration.up|buff.astral_acceleration.remains>5|astral_power.deficit<40))|(variable.starfall_st&!debuff.stellar_empowerment.up)"
					,"solar_wrath,if=buff.solar_empowerment.stack=3&astral_power.deficit>10"
					,"lunar_strike,if=buff.lunar_empowerment.stack=3&astral_power.deficit>15"
					,"starsurge,if=astral_power.deficit<40|(buff.celestial_alignment.up|buff.incarnation.up|buff.astral_acceleration.remains>5|(set_bonus.tier21_4pc&!buff.solar_solstice.up))|(gcd.max*(astral_power/40))>target.time_to_die"
					,"new_moon,if=astral_power.deficit>10&(!(buff.celestial_alignment.up|buff.incarnation.up)|(charges=2&recharge_time<5)|charges=3)"
					,"half_moon,if=astral_power.deficit>20&(!(buff.celestial_alignment.up|buff.incarnation.up)|(charges=2&recharge_time<5)|charges=3)"
					,"full_moon,if=astral_power.deficit>40"
					,"lunar_strike,if=buff.warrior_of_elune.up&buff.lunar_empowerment.up"
					,"solar_wrath,if=buff.solar_empowerment.up"
					,"lunar_strike,if=buff.lunar_empowerment.up"
					,"solar_wrath")
		end

	elseif x.Spec == 2 then
		-- Feral

		x.Energy = s.Power("player", SPELL_POWER_ENERGY )
		x.MaxEnergy = s.MaxPower("player", SPELL_POWER_ENERGY)
		x.EnergyDeficit = x.MaxEnergy - x.Energy
		x.EnergyRegen = s.PowerRegeneration()
		x.CP = s.Power("player", SPELL_POWER_COMBO_POINTS)

		s.UpdateDoT(1079, "Rip")
		s.UpdateDoT(1822, "Rake")
		s.UpdateDoT(106830, "Thrash")
		s.UpdateCooldown(106830, "Thrash")

		s.UpdateBuff(69369, "Predatory Swiftness")
		s.UpdateBuff(145152, "Bloodtalons")
		s.UpdateBuff(102543, "incarnation")
		s.UpdateBuff(5217, "Tiger's Fury")
		s.UpdateBuff(135700, "Clearcasting")
		s.UpdateBuff(252752, "Apex Predator")
		s.UpdateBuff(106951, "Berserk")

		x.HalvedCost = buff.berserk.up or buff.incarnation.up

		action.rake.cost = s.If(x.HalvedCost, 18, 35)
		action.shred.cost = s.If(buff.clearcasting.up, 0, s.If(x.HalvedCost, 20, 40))
		action.moonfire.cost = s.If(x.HalvedCost, 15, 30)
		action.thrash.cost = s.If(buff.clearcasting.up, 0, s.If(x.HalvedCost, 23, 45))
		action.brutal_slash.cost = s.If(buff.clearcasting.up, 0, s.If(x.HalvedCost, 10, 20))
		action.swipe.cost = s.If(buff.clearcasting.up, 0, s.If(x.HalvedCost, 20, 40))
		action.rip.cost = s.If(x.HalvedCost, 15, 30)
		action.ferocious_bite.cost = s.If(x.HalvedCost, 13, 25)

		x.UseThrash = s.If(equipped.luffa_wrappings, 1, 0)

		a.Flash("cat_form,if=!buff.cat_form.up")
		a.Flash("skull_bash")
		a.Flash("prowl")
		a.Flash("wild_charge_cat") -- if we are not in range, use these

		s.UpdateBuff(5215, "Prowl")

		if s.Time() <= 15 and not dot.rip.ticking and s.Boss("target") then
			-- Opener
			a.Flash("rake,if=!ticking|buff.prowl.up"
					,"dash,if=!buff.cat_form.up"
					,"moonfire_cat,if=talent.lunar_inspiration.enabled&!ticking"
					,"savage_roar,if=!buff.savage_roar.up"
					,"berserk"
					,"incarnation"
					,"tigers_fury"
					,"ashamanes_frenzy"
					,"regrowth,if=(talent.sabertooth.enabled|buff.predatory_swiftness.up)&talent.bloodtalons.enabled&buff.bloodtalons.down&combo_points=5"
					,"rip,if=combo_points=5"
					,"thrash_cat,if=!ticking&variable.use_thrash>0"
					,"shred")
		else
			s.UpdateCooldown(5217, "Tiger's Fury")
			s.UpdateCooldown(210722, "Ashamane's Frenzy")
			s.UpdateBuff(252071, "Jungle Stalker")

			-- Single Target
			if a.Flash("rake,if=buff.prowl.up|buff.shadowmeld.up") then
				return
			end

			-- Cooldowns
			a.Flash("dash,if=!buff.cat_form.up"
					,"prowl,if=buff.incarnation.remains<0.5&buff.jungle_stalker.up"
					,"berserk,if=energy>=30&(cooldown.tigers_fury.remains>5|buff.tigers_fury.up)"
					,"tigers_fury,if=energy.deficit>=60"
					,"berserking"
					,"elunes_guidance,if=combo_points=0&energy>=50"
					,"incarnation,if=energy>=30&(cooldown.tigers_fury.remains>15|buff.tigers_fury.up)"
					,"potion,name=prolonged_power,if=target.time_to_die<65|(time_to_die<180&(buff.berserk.up|buff.incarnation.up))"
					,"ashamanes_frenzy,if=combo_points>=2&(!talent.bloodtalons.enabled|buff.bloodtalons.up)"
--					,"shadowmeld,if=combo_points<5&energy>=action.rake.cost&dot.rake.pmultiplier<2.1&buff.tigers_fury.up&(buff.bloodtalons.up|!talent.bloodtalons.enabled)&(!talent.incarnation.enabled|cooldown.incarnation.remains>18)&!buff.incarnation.up"
			)

			-- Single Target
			if a.Flash("ferocious_bite,target_if=dot.rip.ticking&dot.rip.remains<3&target.time_to_die>10&(target.health.pct<25|talent.sabertooth.enabled)"
					,"regrowth,if=combo_points=5&buff.predatory_swiftness.up&talent.bloodtalons.enabled&buff.bloodtalons.down&(!buff.incarnation.up|dot.rip.remains<8)"
					,"regrowth,if=combo_points>3&talent.bloodtalons.enabled&buff.predatory_swiftness.up&buff.apex_predator.up&buff.incarnation.down"
					,"ferocious_bite,if=buff.apex_predator.up&((combo_points>4&(buff.incarnation.up|talent.moment_of_clarity.enabled))|(talent.bloodtalons.enabled&buff.bloodtalons.up&combo_points>3))") then
				return
			end

			-- Finishers
			if a.Flash(--,"pool_resource,for_next=1"
					"savage_roar,if=buff.savage_roar.down"
--					,"pool_resource,for_next=1"
					,"rip,target_if=!ticking|(remains<=duration*0.3)&(target.health.pct>25&!talent.sabertooth.enabled)|(remains<=duration*0.8&persistent_multiplier>dot.rip.pmultiplier)&target.time_to_die>8"
--					,"pool_resource,for_next=1"
					,"savage_roar,if=buff.savage_roar.remains<12"
					,"maim,if=buff.fiery_red_maimers.up"
					,"ferocious_bite,max_energy=1") then
				return
			end

			-- Generators
			a.Flash("regrowth,if=talent.bloodtalons.enabled&buff.predatory_swiftness.up&buff.bloodtalons.down&combo_points>=2&cooldown.ashamanes_frenzy.remains<gcd"
					,"regrowth,if=talent.bloodtalons.enabled&buff.predatory_swiftness.up&buff.bloodtalons.down&combo_points=4&dot.rake.remains<4"
					,"regrowth,if=equipped.ailuro_pouncers&talent.bloodtalons.enabled&(buff.predatory_swiftness.stack>2|(buff.predatory_swiftness.stack>1&dot.rake.remains<3))&buff.bloodtalons.down"
					,"brutal_slash,if=spell_targets.brutal_slash>desired_targets"
--					,"pool_resource,for_next=1"
					,"thrash_cat,if=refreshable&(spell_targets.thrash_cat>2)"
--					,"pool_resource,for_next=1"
					,"thrash_cat,if=spell_targets.thrash_cat>3&equipped.luffa_wrappings&talent.brutal_slash.enabled"
--					,"pool_resource,for_next=1"
					,"rake,target_if=!ticking|(!talent.bloodtalons.enabled&remains<duration*0.3)&target.time_to_die>4"
--					,"pool_resource,for_next=1"
					,"rake,target_if=talent.bloodtalons.enabled&buff.bloodtalons.up&((remains<=7)&persistent_multiplier>dot.rake.pmultiplier*0.85)&target.time_to_die>4"
					,"brutal_slash,if=(buff.tigers_fury.up&(raid_event.adds.in>(1+max_charges-charges_fractional)*recharge_time))"
					,"moonfire_cat,target_if=refreshable"
--					,"pool_resource,for_next=1"
					,"thrash_cat,if=refreshable&(variable.use_thrash=2|spell_targets.thrash_cat>1)"
					,"thrash_cat,if=refreshable&variable.use_thrash=1&buff.clearcasting.react"
--					,"pool_resource,for_next=1"
					,"swipe_cat,if=spell_targets.swipe_cat>1"
					,"shred,if=dot.rake.remains>(action.shred.cost+action.rake.cost-energy)%energy.regen|buff.clearcasting.react")
		end



	elseif x.Spec == 3 then
		-- Guardian
		x.Rage = s.Power("player", SPELL_POWER_RAGE )
		x.MaxRage = s.MaxPower("player", SPELL_POWER_RAGE)

		s.UpdateBuff(192081, "Ironfur")
		s.UpdateBuff(201671, "Gory Fur")
		s.UpdateBuff(102558, "incarnation")
		s.UpdateBuff(213708, "Galactic Guardian")
		s.UpdateBuff(158792, "Pulverize")

		s.UpdateDoT(8921, "Moonfire")
		s.UpdateDoT(77758, "Thrash")

		s.UpdateCooldown(77758, "Thrash")

		a.Flash("stance,choose=bear_form")
		a.Flash("Wild Charge") -- if we are not in range, use these
		a.Flash("skull_bash") -- interrupt spellcasting
		a.Flash("Growl") -- taunt if tanking and not keeping aggro
		x.Stop = false
		a.Flash("auto_attack",
				"berserking",
--				"use_item,slot=trinket2",
				"incarnation",
				"rage_of_the_sleeper",
				"lunar_beam",
				"frenzied_regeneration,if=incoming_damage_5s%health.max>=0.5|health<=health.max*0.4",
				"bristling_fur,if=buff.ironfur.stack=1|buff.ironfur.down",
				"ironfur,if=(buff.ironfur.up=0)|(buff.gory_fur.up=1)|(rage>=80)",
				"moonfire,if=buff.incarnation.up=1&dot.moonfire.remains<=4.8",
				"thrash_bear,if=buff.incarnation.up=1&dot.thrash.remains<=4.5",
				"mangle",
				"thrash_bear",
				"pulverize,if=buff.pulverize.up=0|buff.pulverize.remains<=6",
				"moonfire,if=buff.galactic_guardian.up=1&(!ticking|dot.moonfire.remains<=4.8)",
				"moonfire,if=buff.galactic_guardian.up=1",
				"moonfire,if=dot.moonfire.remains<=4.8",
				"swipe_bear")
	end
end)
